#include <iostream>
#include <cmath>

template<typename T>
void tangent_newton(T& x_v, T& x_t, const T& p_v, const T& p_t, const T& eps) {
  do {
    x_t+=p_t/(2*x_v)-(3./4.+p_v/(4*x_v*x_v))*x_t;
    x_v-=(x_v*x_v-p_v)/(2*x_v);
  } while (fabs(x_v*x_v-p_v)>eps);
}

int main() {
  using T=double;
  T p_v=2, x_v=10, p_t=1, x_t=0;
  const T eps=1e-12;
  x_t=2*x_v*x_t; x_v=pow(x_v,2);
  tangent_newton(x_v,x_t,p_v,p_t,eps);
  x_v=exp(-x_v); x_t=-x_v*x_t;
  std::cout << "x=" << x_v << std::endl;
  std::cout << "dxdp=" << x_t << std::endl;
  return 0;
}
