#pragma once
#include "f12.h"
#include <vector>
#include <random>
#include <cmath>

template <typename T, typename Tp, typename To=float>
T f(int np, int nb, int ns, int nc, T x, const std::vector<std::vector<Tp>>& p) {
  using namespace std;
  default_random_engine g; normal_distribution<To> d(0,1);
  T y=0, x_in=x; To dt=1./ns;
  for (int ib=0;ib<np;ib+=np/nb)
    for (int i=ib;i<ib+np/nb;++i) {
    x=x_in;
    for (int jc=0;jc<ns;jc+=ns/nc) 
      for (int j=jc,k=1;j<jc+ns/nc;++j,k+=2) 
        x+=dt*f1(x,p[0][j])+f2(x,p[1][j])*sqrt(dt)*d(g);
    y+=x;
  }
  return pow(y/np,2);
}
