#include "f.h" 
#include "dco.hpp" 

int main(int argc, char* argv[]) {
  assert(argc==3); 
  int np=std::stoi(argv[1]), ns=std::stoi(argv[2]); assert(np>0&&ns>0);
  using Tb=double; 
  std::cout.precision(std::numeric_limits<Tb>::digits10);
  using Tp=dco::gt1s<Tb>::type; using T=Tp;
  T x=1,y; std::vector<std::vector<Tp>> p(2,std::vector<Tp>(ns,1));
  dco::derivative(x)=1;
  y=f(np,ns,x,p); 
  dco::derivative(x)=0;
  std::cout << "dydx=" << dco::derivative(y) << std::endl;
  for (int i=0;i<ns;++i) { 
    dco::derivative(p[0][i])=1; 
    y=f(np,ns,x,p); 
    std::cout << "dydp[0][" << i << "]=" << dco::derivative(y) << std::endl;
    dco::derivative(p[0][i])=0; dco::derivative(p[1][i])=1; 
    y=f(np,ns,x,p); 
    std::cout << "dydp[1][" << i << "]=" << dco::derivative(y) << std::endl;
    dco::derivative(p[1][i])=0; 
  }
  std::cout << "y=" << dco::value(y) << std::endl;
  return 0;
}
