#include "f.h"
#include "dco.hpp"

int main(int argc, char* argv[]) {
  assert(argc==3); 
  int np=std::stoi(argv[1]), ns=std::stoi(argv[2]); assert(np>0&&ns>0);
  using Tbb=double; std::cout.precision(std::numeric_limits<Tbb>::digits10);
  using Tb=dco::gt1s<Tbb>::type; using Tp=dco::gt1s<Tb>::type; using T=Tp;
  T x=1,y; std::vector<std::vector<Tp>> p(2,std::vector<Tp>(ns,1));
  // d(dy/dx)/dx
  dco::derivative(dco::value(x))=1; dco::value(dco::derivative(x))=1;
  y=f(np,ns,x,p); 
  std::cout << "d(dy/dx)/dx=" << dco::derivative(dco::derivative(y)) << std::endl;
  dco::value(dco::derivative(x))=0; 
  for (int j=0;j<ns;++j) {
    // d(dy/dx)/dp[0][j]
    dco::value(dco::derivative(p[0][j]))=1;
    y=f(np,ns,x,p); 
    std::cout << "d(dy/dx)/dp[0][" << j << "]=" << dco::derivative(dco::derivative(y)) << std::endl;
    dco::value(dco::derivative(p[0][j]))=0;
    // d(dy/dx)/dp[1][j]
    dco::value(dco::derivative(p[1][j]))=1;
    y=f(np,ns,x,p); 
    std::cout << "d(dy/dx)/dp[1][" << j << "]=" << dco::derivative(dco::derivative(y)) << std::endl;
    dco::value(dco::derivative(p[1][j]))=0;
  }
  dco::derivative(dco::value(x))=0;
  for (int i=0;i<ns;++i) {
    // d(dy/dp[0][i])/dx
    dco::derivative(dco::value(p[0][i]))=1;
    dco::value(dco::derivative(x))=1;
    y=f(np,ns,x,p); 
    std::cout << "d(dy/dp[0][" << i << "])/dx=" << dco::derivative(dco::derivative(y)) << std::endl;
    dco::value(dco::derivative(x))=0; 
    for (int j=0;j<ns;++j) {
      // d(dy/dp[0][i])/dp[0][j]
      dco::value(dco::derivative(p[0][j]))=1;
      y=f(np,ns,x,p); 
      std::cout << "d(dy/dp[0][" << i << "])/dp[0][" << j << "]=" << dco::derivative(dco::derivative(y)) << std::endl;
      dco::value(dco::derivative(p[0][j]))=0;
      // d(dy/dp[0][i])/dp[1][j]
      dco::value(dco::derivative(p[1][j]))=1;
      y=f(np,ns,x,p); 
      std::cout << "d(dy/dp[0][" << i << "])/dp[1][" << j << "]=" << dco::derivative(dco::derivative(y)) << std::endl;
      dco::value(dco::derivative(p[1][j]))=0;
    }
    dco::derivative(dco::value(p[0][i]))=0;
    // d(dy/dp[1][i])/dx
    dco::derivative(dco::value(p[1][i]))=1;
    dco::value(dco::derivative(x))=1;
    y=f(np,ns,x,p); 
    std::cout << "d(dy/dp[1][" << i << "])/dx=" << dco::derivative(dco::derivative(y)) << std::endl;
    dco::value(dco::derivative(x))=0; 
    for (int j=0;j<ns;++j) {
      // d(dy/dp[1][i])/dp[0][j]
      dco::value(dco::derivative(p[0][j]))=1;
      y=f(np,ns,x,p); 
      std::cout << "d(dy/dp[1][" << i << "])/dp[0][" << j << "]=" << dco::derivative(dco::derivative(y)) << std::endl;
      dco::value(dco::derivative(p[0][j]))=0;
      // d(dy/dp[1][i])/dp[1][j]
      dco::value(dco::derivative(p[1][j]))=1;
      y=f(np,ns,x,p); 
      std::cout << "d(dy/dp[1][" << i << "])/dp[1][" << j << "]=" << dco::derivative(dco::derivative(y)) << std::endl;
      dco::value(dco::derivative(p[1][j]))=0;
    }
    dco::derivative(dco::value(p[1][i]))=0;
  }
  std::cout << "y=" << dco::value(dco::value(y)) << std::endl;
  return 0;
}
