#include "f.h" 
#include "dco.hpp" 

int main(int argc, char* argv[]) {
  assert(argc==3); 
  int np=std::stoi(argv[1]), ns=std::stoi(argv[2]); assert(np>0&&ns>0);
  using Tb=double; 
  std::cout.precision(std::numeric_limits<Tb>::digits10);
  const int VS=21; assert(VS>=2*ns+1);
  using Tp=dco::gt1v<Tb,VS>::type; using T=Tp;
  T x=1,y; std::vector<std::vector<Tp>> p(2,std::vector<Tp>(ns,1));
  dco::derivative(x)[0]=1;
  for (int i=0,j=1;i<ns;++i,j+=2) { 
    dco::derivative(p[0][i])[j]=1; 
    dco::derivative(p[1][i])[j+1]=1; 
  }
  y=f(np,ns,x,p); 
  std::cout << "dy/dx=" << dco::derivative(y)[0] << std::endl;
  for (int i=0,j=1;i<ns;++i,j+=2) { 
    std::cout << "dy/dp[0][" << i << "]=" << dco::derivative(y)[j] << std::endl;
    std::cout << "dy/dp[1][" << i << "]=" << dco::derivative(y)[j+1] << std::endl;
  }
  std::cout << "y=" << dco::value(y) << std::endl;
  return 0;
}
