// naumann@stce.rwth-aachen.de
#include <iostream>
#include "F.hpp"

int main() {
  using namespace std;
  AT x=1.5, vh, vg, y;
  AM::global_tape=AM::tape_t::create(); 
  cout << "1: " << dco::size_of(AM::global_tape) << endl;
  AM::global_tape->register_variable(x); 
  vh=h(x); 
  cout << "2: " << dco::size_of(AM::global_tape) << endl;
  AM::tape_t::position_t pos=AM::global_tape->get_position(); 
  vg=g(x,vh); 
  cout << "3: " << dco::size_of(AM::global_tape) << endl;
  double pvg=dco::value(vg);
  dco::derivative(vg)=1; // seed identity
  AM::global_tape->interpret_adjoint_to(pos); 
  cout << "4: " << dco::size_of(AM::global_tape)-8 << endl;
  AM::global_tape->reset_to(pos); 
  cout << "5: " << dco::size_of(AM::global_tape)-8 << endl;
  vg=x*dco::derivative(x)+vh*dco::derivative(vh);
  dco::derivative(x)=0; dco::derivative(vh)=0;
  dco::value(vg)=pvg;
  cout << "6: " << dco::size_of(AM::global_tape)-8 << endl;
  dco::derivative(vg)=1;
  AM::global_tape->interpret_adjoint_to(pos);
  cout << "7: " << dco::size_of(AM::global_tape)-8 << endl;
  AM::global_tape->reset_to(pos);
  cout << "8: " << dco::size_of(AM::global_tape)-8 << endl;
  y=f(x,vh,pvg); 
  cout << "9: " << dco::size_of(AM::global_tape)-8 << endl;
  dco::derivative(y)=1; // seed 
  AM::global_tape->interpret_adjoint(); 
  cout << "10: " << dco::size_of(AM::global_tape)-8 << endl;
  cout << dco::value(y) << ' ' << dco::derivative(x) << endl;
  AM::tape_t::remove(AM::global_tape); 
  return 0;
}
