// Uwe.Naumann@nag.com
#include <iostream>
#include "F.hpp"

int main() {
  using namespace std;
  AT x=1.5, vh, vg, y;
  AM::global_tape=AM::tape_t::create(); 
  AM::global_tape->register_variable(x); 
  vh=h(x); 
  AM::jacobian_preaccumulator_t jp(AM::global_tape); 
  jp.start();
  vg=g(x,vh); 
  jp.register_output(vg);
  jp.finish();
  y=f(x,vh,vg); 
  dco::derivative(y)=1; 
  AM::global_tape->interpret_adjoint(); 
  cout << dco::value(y) << ' ' << dco::derivative(x) << endl;
  AM::tape_t::remove(AM::global_tape); 
  return 0;
}
