// naumann@stce.rwth-aachen.de
#include <iostream>
#include "F.hpp"

int main() {
  using namespace std;
  AT x=1.5, vh, vg, y;
  AM::global_tape=AM::tape_t::create(); 
  cout << "1: " << dco::size_of(AM::global_tape) << endl;
  AM::global_tape->register_variable(x); 
  vh=h(x); 
  cout << "2: " << dco::size_of(AM::global_tape) << endl;
  TT xt=dco::value(x), vht=dco::value(vh);
  dco::derivative(xt)[0]=1; dco::derivative(vht)[1]=1;
  TT vgt=g(xt,vht); 
  cout << "3: " << dco::size_of(AM::global_tape) << endl;
  vg=x*dco::derivative(vgt)[0]+vh*dco::derivative(vgt)[1];
  cout << "4: " << dco::size_of(AM::global_tape) << endl;
  dco::value(vg)=dco::value(vgt);
  y=f(x,vh,vg); 
  cout << "5: " << dco::size_of(AM::global_tape) << endl;
  dco::derivative(y)=1; 
  AM::global_tape->interpret_adjoint(); 
  cout << "6: " << dco::size_of(AM::global_tape)-8 << endl;
  cout << dco::value(y) << ' ' << dco::derivative(x) << endl;
  AM::tape_t::remove(AM::global_tape); 
  return 0;
}
