// naumann@stce.rwth-aachen.de
#include <iostream>
#include "F.hpp"

int main() {
  using namespace std;
  AT x=1.5, vh, vg, y;
  AM::global_tape=AM::tape_t::create(); 
  cout << "1: " << dco::size_of(AM::global_tape) << endl;
  AM::global_tape->register_variable(x); 
  vh=h(x); 
  cout << "2: " << dco::size_of(AM::global_tape) << endl;
  // correction for (obsoltete) checkpoint
  cout << "3: " << dco::size_of(AM::global_tape)+2 << endl;
  dco::value(vg)=g(dco::value(x),dco::value(vh)); 
  cout << "4: " << dco::size_of(AM::global_tape)+2 << endl;
  AM::tape_t::position_t pos1=AM::global_tape->get_position(); 
  AM::global_tape->register_variable(vg); 
  AM::tape_t::position_t pos2=AM::global_tape->get_position(); 
  y=f(x,vh,vg); 
  cout << "5: " << dco::size_of(AM::global_tape)+2 << endl;
  dco::derivative(y)=1; // seed 
  AM::global_tape->interpret_adjoint_to(pos2); 
  cout << "6: " << dco::size_of(AM::global_tape)+2-8 << endl;
  double adjoint_vg=dco::derivative(vg); 
  double adjoint_vh=dco::derivative(vh); dco::derivative(vh)=0; 
  double adjoint_x=dco::derivative(x); dco::derivative(x)=0;
  AM::global_tape->reset_to(pos1); 
  cout << "7: " << dco::size_of(AM::global_tape)+2-8 << endl;
  // correction for recovered (obsoltete) checkpoint
  cout << "8: " << dco::size_of(AM::global_tape)-8 << endl;
  vg=g(x,vh);
  cout << "8: " << dco::size_of(AM::global_tape)-8 << endl;
  dco::derivative(vg)=1; 
  AM::global_tape->interpret_adjoint_to(pos1); 
  cout << "9: " << dco::size_of(AM::global_tape)-8 << endl;
  AM::global_tape->reset_to(pos1); 
  cout << "10: " << dco::size_of(AM::global_tape)-8 << endl;
  vg=x*dco::derivative(x)+vh*dco::derivative(vh);
  cout << "11: " << dco::size_of(AM::global_tape)-8 << endl;
  dco::derivative(x)=adjoint_x;
  dco::derivative(vh)=adjoint_vh;
  dco::derivative(vg)=adjoint_vg;
  AM::global_tape->interpret_adjoint(); 
  cout << "12: " << dco::size_of(AM::global_tape)-8 << endl;
  cout << dco::value(y) << ' '<< dco::derivative(x) << endl;
  AM::tape_t::remove(AM::global_tape);
  return 0;
}
