// naumann@stce.rwth-aachen.de
#include <iostream>
#include "F.hpp"

int main() {
  using namespace std;
  AT x=1.5, vh, vg, y;
  AM::global_tape=AM::tape_t::create(); 
  cout << "1: " << dco::size_of(AM::global_tape) << endl;
  AM::global_tape->register_variable(x); 
  vh=h(x); 
  cout << "2: " << dco::size_of(AM::global_tape) << endl;
  cout << "3: " << dco::size_of(AM::global_tape)+2 << endl;
  dco::value(vg)=g(dco::value(x),dco::value(vh)); 
  AM::tape_t::position_t pos1=AM::global_tape->get_position(); 
  cout << "4: " << dco::size_of(AM::global_tape)+2 << endl;
  AM::global_tape->register_variable(vg); 
  AM::tape_t::position_t pos2=AM::global_tape->get_position(); 
  y=f(x,vh,vg); 
  cout << "5: " << dco::size_of(AM::global_tape)+2 << endl;
  dco::derivative(y)=1; 
  AM::global_tape->interpret_adjoint_to(pos2); 
  cout << "6: " << dco::size_of(AM::global_tape)+2-8 << endl;
  double adjoint_vg=dco::derivative(vg); 
  AM::global_tape->reset_to(pos1); 
  cout << "7: " << dco::size_of(AM::global_tape)+2-8 << endl;
  cout << "8: " << dco::size_of(AM::global_tape)-8 << endl;
  vg=g(x,vh); 
  cout << "9: " << dco::size_of(AM::global_tape)-8 << endl;
  dco::derivative(vg)=adjoint_vg; 
  AM::global_tape->interpret_adjoint(); 
  cout << "10: " << dco::size_of(AM::global_tape)-8 << endl;
  cout << dco::value(y) << ' ' << dco::derivative(x) << endl;
  AM::tape_t::remove(AM::global_tape); 
  return 0;
}
